unit Bdetool1;

(*
a little demo on how to use some useful and often asked for DBI
calls from within Delphi.

this 'app' is by no means error proof, it's just meant to 'give
an idea'...

most of the examples can be simplified if you're using only one
type of tables.

For more information refer to DBI*.INT files in \delphi\doc and
download BDEHLP.ZIP from CIS/Delphi.

this is free, and I won't take any responsibility for your data!
please be careful using these functions, esp. with protecting
tables!

any comments appreciated,

Reinhard Kalinke
100417,305@compuserve.com
feb 27, 1996

P.S. and BTW: if you want to use pictures and valchecks with your
Paradox tables, have a look at PICEDITS.ZIP in lib 5 and another
at PXVALTBL.ZIP in lib 6 of CIS/Delphi...
*)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, StdCtrls, Grids, DBGrids, FileCtrl,
  DBIProcs,DBITypes,DBIErrs, ExtCtrls, DBCtrls, Mask;

type
  TForm1 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    PackButton: TButton;
    CopyButton: TButton;
    ProtectButton: TButton;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    ExitButton: TButton;
    Table1: TTable;
    DataSource1: TDataSource;
    SaveDialog1: TSaveDialog;
    Bevel1: TBevel;
    Label1: TLabel;
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    RenameButton: TButton;
    DeleteButton: TButton;
    UserButton: TButton;
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure Table1AfterOpen(DataSet: TDataset);
    procedure Table1BeforeClose(DataSet: TDataset);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure CopyButtonClick(Sender: TObject);
    procedure RenameButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure PackButtonClick(Sender: TObject);
    procedure ProtectButtonClick(Sender: TObject);
    procedure UserButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
    TblProps: CURProps;
    procedure Action(IsOn: boolean);
    function GetFileName(var NewName: TFileName):boolean;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Table1AfterOpen(DataSet: TDataset);
begin
  {we will need this info in a couple of situations:}
  DBIGetCursorProps(Table1.Handle,TblProps);
  Action(true);
end;

procedure TForm1.Table1BeforeClose(DataSet: TDataset);
begin
  {invalidate tablecursorinfo:}
  FillChar(TblProps,sizeOf(CURProps),0);
end;

procedure TForm1.Action(IsOn: boolean);
begin
  CopyButton.Enabled := IsOn;
  RenameButton.Enabled := IsOn;
  DeleteButton.Enabled := IsOn;
  PackButton.Enabled := IsOn;
  ProtectButton.Enabled := IsOn and (StrPas(TblProps.szTableType)
                                     = szPARADOX);
  if IsOn then
    Label1.Caption := ' Action is on '
  else
  begin
    Label1.Caption := ' Action is off ';
    Panel1.Caption := '???';
  end;
end;

procedure TForm1.DirectoryListBox1Change(Sender: TObject);
begin
  if Table1.Active then Table1.Close;
  Action(False);
end;

procedure TForm1.FileListBox1Change(Sender: TObject);
begin
  if FileListBox1.FileName <> '' then
  with Table1 do
  begin
    Close;
    TableName := FileListBox1.FileName;
    Exclusive := True;
    try
      Open;
    except
      Exclusive := False;
      Open;
    end;
  end
  else
    Action(False);
end;

{the recordNo-panel:}
procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var RcrdProps: RECProps;  {req for dBase only}
    RcrdNo: longint;
    BDERes: DBIResult;
begin
  with Table1 do
  begin
    BDERes := 0;
    UpdateCursorPos;
    if BOF then
      RcrdNo := 1
    else
      if EOF then
        RcrdNo := RecordCount
      else
        if StrPas(TblProps.szTableType) = szPARADOX then
          BDERes := DBIGetSeqNo(Handle,RcrdNo)
        else
        begin
          BDERes := DBIGetRecord(Handle,dbiNOLOCK,nil,@RcrdProps);
          RcrdNo := RcrdProps.iPhyRecNum;
        end;
    if BDERes = 0 then
      Panel1.Caption := IntToStr(RcrdNo)+' of '+IntToStr(RecordCount)
    else
      Panel1.Caption := '??? of '+IntToStr(RecordCount);
  end; {with Table1}
end;


function TForm1.GetFileName(var NewName: TFileName):boolean;
begin
  with SaveDialog1 do
  begin
    NewName := '';
    Result := False;
    {tell the tabletype without TblProps this time:}
    DefaultExt := copy(ExtractFileExt(Table1.TableName),2,3);
    if (Uppercase(DefaultExt) = 'DBF') then
      Filter := 'dBase table|*.dbf'
    else
      Filter := 'Paradox table|*.db';
    Result := Execute;
    if Result then
      NewName := Filename;
    {do not allow another ext:}
    if Result and (ofExtensionDifferent in Options) then
    begin
      Result := False;
      {raising an invalid filename error:}
      DBIError(DBIERR_INVALIDFILENAME);
    end;
  end; {with SaveDialog1}
end;

procedure TForm1.CopyButtonClick(Sender: TObject);
var NewTblName: TFileName;
    pSrcTblName, pDestTblName: DBITBLNAME;
    BDERes: DBIRESULT;
begin
  if GetFileName(NewTblName) then
  begin
    with Table1 do
    begin
      {processing of 'foreign' characters:}
      AnsiToNative(DBLocale,TableName,pSrcTblName,255);
      AnsiToNative(DBLocale,NewTblName,pDestTblName,255);
      BDERes:=DBICopyTable(DBHandle,
                   False,  {Overwrite, if table already exists}
                   pSrcTblName,
                   nil,    {tabletype, can be nil if filenames have extensions}
                   pDestTblName);
      if (BDERes <> DBIERR_NONE) then
       {raising the error:}
        DBIError(BDERes)
      else
      begin
        {Updating the filelist:}
        FileListBox1.Update;
        FileListBox1.FileName := TableName;
      end;
    end;
  end;
end;

procedure TForm1.RenameButtonClick(Sender: TObject);
var pSrcTblName, pDestTblName: DBITBLNAME;
    NewTblName: TFileName;
    hDB: hDBIdb;
    RLocale: TLocale;
    BDERes: DBIRESULT;
begin
  if GetFileName(NewTblName) then
  begin
    with Table1 do
    begin
      {save dbhandle and dblocale,
       we will have to close that table:}
      hDB := DBHandle;
      RLocale := DBLocale;
      AnsiToNative(RLocale,TableName,pSrcTblName,255);
      AnsiToNative(RLocale,NewTblName,pDestTblName,255);
      Close;
      BDERes:=DBIRenameTable(hDB,
                   pSrcTblName,
                   nil,    {tabletype, can be nil if filenames have extensions}
                   pDestTblName);
      if (BDERes <> DBIERR_NONE) then
      begin
        try Open;
        finally DBIError(BDERes);
        end;
      end
      else
      begin
        {connect new tablename, update filelist:}
        NativeToAnsi(RLocale,pDestTblName,NewTblName);
        TableName := NewTblName;
        FileListBox1.Update;
        FileListBox1.FileName := TableName;
      end;
    end;
  end;
end;

procedure TForm1.DeleteButtonClick(Sender: TObject);
var pSrcTblName: DBITBLNAME;
    hDB: hDBIdb;
    BDERes: DBIRESULT;
begin
  if (messageDlg('Do you really want to delete that table?',
                 mtConfirmation,mbOKCancel,0) = mrOK) then
  begin
    with Table1 do
    begin
      AnsiToNative(DBLocale,TableName,pSrcTblName,255);
      hDB := DBHandle;
      Close;
      BDERes:=DBIDeleteTable(hDB,
                   pSrcTblName,
                   nil);    {tabletype, can be nil if filenames have extensions}
      if (BDERes <> DBIERR_NONE) then
      begin
        try Open;
        finally DBIError(BDERes);
        end;
      end
      else
      begin
        {update filelist:}
        TableName := '';
        FileListBox1.Update;
        FileListBox1.ItemIndex := -1;
      end;
    end;
  end;
end;


procedure TForm1.PackButtonClick(Sender: TObject);
var hDB: hDBIdb;
    pTableDesc: pCRTblDesc; {req for Paradox only}
    BDERes: DBIResult;
begin
  pTableDesc := nil;
  with Table1 do
  begin
    if Active and (not Exclusive) then
      Close;
    if (not Exclusive) then
      Exclusive := True;
    if (not Active) then
      Open;
    {Paradox tables:}
    if (StrPas(TblProps.szTableType) = szPARADOX) then
    begin
      {preparing data for DBIDoRestructure:}
      GetMem(pTableDesc,sizeOf(CRTblDesc));
      {supply nulls (=default) for every optional parameter:}
      FillChar(pTableDesc^,SizeOf(CRTblDesc),0);
      {supply required parameters:}
      AnsiToNative(DBLocale,TableName,pTableDesc^.szTblName,255);
      pTableDesc^.szTblType := TblProps.szTableType;
      {supply 'our' parameter here for packing:}
      pTableDesc^.bPack := True;
      hDB := DBHandle;
      Close;
      BDERes := DBIDoRestructure(hDB,
                                 1,
                                 pTableDesc,
                                 nil,{pSaveAs}
                                 nil,{pKeyViol}
                                 nil,{pProblem}
                                 False);
      if pTableDesc <> nil then
        FreeMem(pTableDesc,sizeOf(CRTblDesc));
      Open;
    end
    else
      {dBase is the 'simple' one here:}
      BDERes := DBIPackTable(DBHandle,
                             Handle,
                             nil,   {tablename, nil because handle is supplied}
                             szDBASE,
                             True); {regen indexes or not}
    if (BDERes <> DBIERR_NONE) then
      DBIError(BDERes);
  end;
end;

{this is the most complicated and most dangerous one...}
procedure TForm1.ProtectButtonClick(Sender: TObject);
var hDB: hDBIdb;
    pTableDesc: pCRTblDesc;
    BDERes: DBIResult;
    NewPasswrd: TCaption;
    DoEncrypt: boolean;
    PromptAdd: TCaption;
begin
  NewPasswrd := '';
  pTableDesc := nil;
  {if there is a pw on the table:}
  if TblProps.bProtected then
    PromptAdd := ' / Ok to remove current'
  else
    PromptAdd := '';
  if not InputQuery('Password',
                    'Enter new password'+PromptAdd,
                     NewPasswrd) then
    exit;
  DoEncrypt := (NewPasswrd <> '');
  if ((DoEncrypt) and not (messageDlg(
                     'You won''t be able to access the table'+#10#13
                     +'without this password again!  Proceed?',
                     mtConfirmation,mbOkCancel,0) = mrOK))
  or ((not DoEncrypt) and (not TblProps.bProtected)) then
    exit;
  with Table1 do
  begin
    {make sure we have exclusive access and save the dbhandle:}
    if Active and (not Exclusive) then
      Close;
    if (not Exclusive) then
      Exclusive := True;
    if (not Active) then
      Open;
    hDB := DBHandle;
    Close;
    {preparing data for DBIDoRestructure:}
    GetMem(pTableDesc,sizeOf(CRTblDesc));
    {supply nulls (=default) for every optional parameter:}
    FillChar(pTableDesc^,SizeOf(CRTblDesc),0);
    AnsiToNative(DBLocale,TableName,pTableDesc^.szTblName,255);
    pTableDesc^.szTblType := TblProps.szTableType;
    {supply parameters for our action here:}
    AnsiToNative(DBLocale,NewPasswrd,pTableDesc^.szPassword,255);
    pTableDesc^.bProtected := DoEncrypt; {supply False to decrypt}
    BDERes := DBIDoRestructure(hDB,
                               1,
                               pTableDesc,
                               nil,{pSaveAs}
                               nil,{pKeyViol}
                               nil,{pProblem}
                               False);
    if pTableDesc <> nil then
      FreeMem(pTableDesc,sizeOf(CRTblDesc));
    if (BDERes <> DBIERR_NONE) then
      DBIError(BDERes);
    {reopening the table with passworddialog, if that fails,
     supply password with Session.AddPassword:}
    {this is only an example, of course this is not the way
     to code this in a real app...}
    try try
      Open except end;
    finally
      Session.AddPassword(NewPasswrd);
      Open;
    end;
  end; {with table1}
end;

procedure TForm1.UserButtonClick(Sender: TObject);
var UserName: DBIName;
    UserNameStr: TCaption;
    BDERes: DBIResult;
begin
  BDERes := DBIGetNetUserName(UserName);
  if (BDERes = DBIERR_NONE) then
  begin
    if (UserName[0] <> #0) then
      NativeToAnsi(Table1.DBLocale,UserName,UserNameStr)
    else
      UserNameStr := 'NOT SUPPLIED';
    showmessage('User is logged to the network as: '+UserNameStr);
  end
  else
    DBIError(BDERes);
end;

procedure TForm1.ExitButtonClick(Sender: TObject);
begin
  Table1.Close;
  Form1.Close;
end;

end.
